package com.huimv.receive.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.receive.common.token.TokenSign;
import com.huimv.receive.common.utils.Result;
import com.huimv.receive.common.utils.ResultCode;
import com.huimv.receive.entity.BillCleanBefore;
import com.huimv.receive.entity.BillSampling;
import com.huimv.receive.mapper.BillCleanBeforeMapper;
import com.huimv.receive.service.IBillCleanBeforeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 洗消表 服务实现类
 * </p>
 *
 * @author author
 * @since 2024-03-11
 */
@Service
public class BillCleanBeforeServiceImpl extends ServiceImpl<BillCleanBeforeMapper, BillCleanBefore> implements IBillCleanBeforeService {

    @Autowired
    private BillCleanBeforeMapper billCleanBeforeMapper;

    @Override
    public Result listPersonalCleanBefore(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String vistitType = paramsMap.get("vistitType");
        Integer userId = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        Page<BillCleanBefore> page = new Page<>(Integer.parseInt(pageNo),Integer.parseInt(pageSize));
        LambdaQueryWrapper<BillCleanBefore> queryWrapper = new QueryWrapper<BillCleanBefore>().lambda()
                .eq(BillCleanBefore::getFarmId,farmId)
                .eq(BillCleanBefore::getAdmissionUserId,userId)
                .eq(ObjectUtil.isNotEmpty(vistitType),BillCleanBefore::getVistitType,vistitType)
                .orderByDesc(BillCleanBefore::getSubDate);
        Page<BillCleanBefore> billCleanBeforePage = billCleanBeforeMapper.selectPage(page, queryWrapper);
        Integer count = billCleanBeforeMapper.selectCount(queryWrapper);
        return new Result(ResultCode.SUCCESS,billCleanBeforePage,count);
    }
}
