package com.huimv.receive.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.receive.common.token.TokenSign;
import com.huimv.receive.common.utils.Result;
import com.huimv.receive.common.utils.ResultCode;
import com.huimv.receive.entity.BillSampling;
import com.huimv.receive.mapper.BillSamplingMapper;
import com.huimv.receive.service.IBillSamplingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 洗消表 服务实现类
 * </p>
 *
 * @author author
 * @since 2024-03-11
 */
@Service
public class BillSamplingServiceImpl extends ServiceImpl<BillSamplingMapper, BillSampling> implements IBillSamplingService {

    @Autowired
    private BillSamplingMapper billSamplingMapper;

    @Override
    public Result listPersonalSample(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String vistitType = paramsMap.get("vistitType");
        Integer userId = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        Page<BillSampling> page = new Page<>(Integer.parseInt(pageNo),Integer.parseInt(pageSize));
        LambdaQueryWrapper<BillSampling> queryWrapper = new QueryWrapper<BillSampling>().lambda()
                .eq(BillSampling::getFarmId,farmId)
                .eq(BillSampling::getAdmissionUserId, userId)
                .eq(ObjectUtil.isNotEmpty(vistitType), BillSampling::getVistitType, vistitType)
                .orderByDesc(BillSampling::getSubDate);
        Page<BillSampling> billSamplingPage = billSamplingMapper.selectPage(page,queryWrapper);
        Integer count = billSamplingMapper.selectCount(queryWrapper);
        return new Result(ResultCode.SUCCESS,billSamplingPage,count);
    }
}
